<?PHP

/**
 * *******************************************************************************
 * SugarCRM Community Edition is a customer relationship management program developed by
 * SugarCRM, Inc.
 * Copyright (C) 2004-2013 SugarCRM Inc.
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Affero General Public License version 3 as published by the
 * Free Software Foundation with the addition of the following permission added
 * to Section 15 as permitted in Section 7(a): FOR ANY PART OF THE COVERED WORK
 * IN WHICH THE COPYRIGHT IS OWNED BY SUGARCRM, SUGARCRM DISCLAIMS THE WARRANTY
 * OF NON INFRINGEMENT OF THIRD PARTY RIGHTS.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Affero General Public License for more
 * details.
 *
 * You should have received a copy of the GNU Affero General Public License along with
 * this program; if not, see http://www.gnu.org/licenses or write to the Free
 * Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301 USA.
 *
 * You can contact SugarCRM, Inc. headquarters at 10050 North Wolfe Road,
 * SW2-130, Cupertino, CA 95014, USA. or at email address contact@sugarcrm.com.
 *
 * The interactive user interfaces in modified source and object code versions
 * of this program must display Appropriate Legal Notices, as required under
 * Section 5 of the GNU Affero General Public License version 3.
 *
 * In accordance with Section 7(b) of the GNU Affero General Public License version 3,
 * these Appropriate Legal Notices must retain the display of the "Powered by
 * SugarCRM" logo. If the display of the logo is not reasonably feasible for
 * technical reasons, the Appropriate Legal Notices must display the words
 * "Powered by SugarCRM".
 * ******************************************************************************
 */

/**
 * THIS CLASS IS GENERATED BY MODULE BUILDER
 * PLEASE DO NOT CHANGE THIS CLASS
 * PLACE ANY CUSTOMIZATIONS IN EcmSyntheticAccount
 */
class EcmSyntheticAccount extends Basic {

	var $new_schema = true;
	var $module_dir = 'EcmSyntheticAccounts';
	var $object_name = 'EcmSyntheticAccount';
	var $table_name = 'ecmsyntheticaccounts';
	var $importable = false;
	var $disable_row_level_security = true; // to ensure that modules created and deployed under CE will continue to function under team security if the instance is upgraded to PRO
	var $id;
	var $name;
	var $date_entered;
	var $date_modified;
	var $modified_user_id;
	var $modified_by_name;
	var $created_by;
	var $created_by_name;
	var $description;
	var $deleted;
	var $created_by_link;
	var $modified_user_link;
	var $assigned_user_id;
	var $assigned_user_name;
	var $assigned_user_link;
	var $indeks;
	var $time;
	var $ecmsyntheticaccounts_unit_dom;
	var $category;
	var $cost_action;
	var $cost_hour;
	var $cost_other;

	function EcmSyntheticAccount() {
		parent::Basic();
	}

	function bean_implements($interface) {
		switch ($interface) {
			case 'ACL' :
				return true;
		}
		return false;
	}

	function save($check_notify = false) {
		$return_id = parent::save($check_notify);
		$tmp = array();

		foreach ($_POST['structureanalyticalpart'] as $key => $value) {
			if ($_POST['structureanalyticalpart'][$key] != '') {
				$tmp[$key]['ecmsyntheticaccounts_id'] = $return_id;
				$tmp[$key]['position'] = $key;
				$tmp[$key]['value'] = $_POST['structureanalyticalpart'][$key];
			}
		}
		$this->saveStructureanAlyticalList($tmp);

		$analyticalList = explode(',', $_POST ['tableAnalyticalAccounts_rowOrder']);
		$analytical_array = array();

		foreach ($analyticalList as $value) {
			if ($_POST ['tableAnalyticalAccounts_code_' . $value] != '') {
				$analytical_array [$value] ['code'] = $_POST ['tableAnalyticalAccounts_code_' . $value];
				$analytical_array [$value] ['name'] = $_POST ['tableAnalyticalAccounts_name_' . $value];
			}
		}
		$this->saveAnaliticalList($analytical_array);
	}

	function saveStructureanAlyticalList($pl) {
		global $current_user;
		$exists = array();
		if ($this->id != '') {
			$GLOBALS['db']->query("DELETE FROM ecmsyntheticaccounts_structureanalyticalpart WHERE ecmsyntheticaccounts_id='" . $this->id . "'");
		}
		foreach ($pl as $p) {
			if (!isset($p['ecmsyntheticaccounts_id']) || $p['ecmsyntheticaccounts_id'] == '')
				continue;
			$id = create_guid();
			$t = array(
				$id, //id
				$this->id, //document id
				$p['position'], //user id
				$p['value'], //date accepted
			);
			$q = "INSERT INTO ecmsyntheticaccounts_structureanalyticalpart VALUES ('" . implode("','", $t) . "')";
			$GLOBALS['db']->query($q);
			$exists[] = $id;
		}
	}

	function showStructureanAlyticalList($array = false) {
		$json = getJSONobj();
		if (isset($this->id) && $this->id != '') {
			$query = "SELECT * FROM ecmsyntheticaccounts_structureanalyticalpart WHERE ecmsyntheticaccounts_id='" . $this->id . "' ORDER BY position";
			$r = $this->db->query($query);
			$return_array = array();
			if ($r) {
				while ($w = $this->db->fetchByAssoc($r)) {
					$new = array();
					$new['ecmsyntheticaccounts_id'] = $w['ecmsyntheticaccounts_id'];
					$new['position'] = $w['position'];
					$new['value'] = $w['value'];
					$return_array [] = $new;
				}
				return $array ? $return_array : $return_array;
			}
		}
		return $array ? false : '[]';
	}

	function saveAnaliticalList($pl) {
		$exists = array();
		if ($this->id != '') {
			$GLOBALS ['db']->query("DELETE FROM ecmsyntheticaccounts_analyticalaccounts WHERE ecmsyntheticaccount_id='" . $this->id . "'");
		}
		foreach ($pl as $p) {
			// insert new record
			$id = create_guid();
			$t = array(
				$id,
				$this->id,
				addslashes($p ['code']),
				addslashes($p ['name'])
			);
			$q = "INSERT INTO ecmsyntheticaccounts_analyticalaccounts VALUES ('" . implode("','", $t) . "')";
			$GLOBALS ['db']->query($q);
			$exists [] = $id;
		}
	}

	function getAnaliticalList($array = false) {
		if (isset($this->id) && $this->id != '') {
			$query = "SELECT code, name FROM  ecmsyntheticaccounts_analyticalaccounts WHERE ecmsyntheticaccount_id='" . $this->id . "' ORDER BY code DESC";
			$r = $this->db->query($query);
			$return_array = array();
			if ($r) {
				while ($row = $this->db->fetchByAssoc($r)) {
					$a_json_row ['code'] = $row ['code'];
					$a_json_row ['name'] = $row ['name'];
					$return_array [] = $a_json_row;
				}
				$json = getJSONobj();
				return $array ? $return_array : $return_array;
			}
		}
		return $array ? false : '[]';
	}
}

?>